package cn.ibizlab.assetmanagement.core.location.service;

import java.io.Serializable;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.util.Collection;
import java.math.BigInteger;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import com.alibaba.fastjson.JSONObject;
import org.springframework.cache.annotation.CacheEvict;

import cn.ibizlab.assetmanagement.core.location.domain.EAMLocationType;
import cn.ibizlab.assetmanagement.core.location.filter.EAMLocationTypeSearchContext;


import com.baomidou.mybatisplus.extension.service.IService;

/**
 * 实体[EAMLocationType] 服务对象接口
 */
public interface IEAMLocationTypeService extends IService<EAMLocationType>{

    boolean create(EAMLocationType et) ;
    void createBatch(List<EAMLocationType> list) ;
    boolean update(EAMLocationType et) ;
    void updateBatch(List<EAMLocationType> list) ;
    boolean remove(String key) ;
    void removeBatch(Collection<String> idList) ;
    EAMLocationType get(String key) ;
    EAMLocationType getDraft(EAMLocationType et) ;
    boolean checkKey(EAMLocationType et) ;
    boolean save(EAMLocationType et) ;
    void saveBatch(List<EAMLocationType> list) ;
    Page<EAMLocationType> searchDefault(EAMLocationTypeSearchContext context) ;
    List<EAMLocationType> selectByEamlocationstatemodelid(String eamlocationstatemodelid) ;
    void removeByEamlocationstatemodelid(String eamlocationstatemodelid) ;
    /**
     *自定义查询SQL
     * @param sql  select * from table where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return select * from table where id = '1'
     */
    List<JSONObject> select(String sql, Map param);
    /**
     *自定义SQL
     * @param sql  update table  set name ='test' where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return     update table  set name ='test' where id = '1'
     */
    boolean execute(String sql, Map param);

    List<EAMLocationType> getEamlocationtypeByIds(List<String> ids) ;
    List<EAMLocationType> getEamlocationtypeByEntities(List<EAMLocationType> entities) ;
}


